// Ouvre le fichier texte jouineau_sport_Pitch_listing.txt
// placé dans le dossier data
// Dessine la courbe
// 

/**
 * Touche Espace    Pause <br>
 * Touche Fleche <- Zoom Out <br>
 * Touche Fleche -> Zoom In <br>
 * Clic souris dans la fenêtre d'abord <br> <br>
 * Ouvre et joue le fichier Audio jouineau_sport.wav <br>
 * Ouvre le fichier texte jouineau_sport_Pitch_listing.txt <br>
 * Dessine la courbe de pitch synchronisée avec l'Audio <br>
 * La courbe n'est pas dessinée quand pitch est "undefined" <br>
 * Chronomètre... <br>
 */

import ddf.minim.*;  // pour AudioPlayer

PFont maFonte;
String Texte1Nom = "jouineau_sport_Pitch_listing.txt";
String AudioNom = "jouineau_sport.wav";
String[] lignes;
int index = 0;
float xavant, xapres, yavant, yapres;
int Ligne, x;
AudioPlayer player;
Minim minim;
float temps, DureeFichier;
boolean ToucheEspace = false, Pause = false, Trace = false;
float[] nums;
float TempsPause, TempsDebutPause = 0, FacteurX = 8;

void setup() {
  size(800, 600);  // "The size() function must be the first line in setup()"
  maFonte = loadFont("Helvetica-50.vlw");
  smooth();
  background(255);
  stroke(160);
  textAlign(LEFT, TOP); //RIGHT LEFT BOTTOM BASELINE TOP
  if (loadStrings(Texte1Nom) == null) { 
    println("Le fichier " + Texte1Nom + " n'existe pas");
    exit();
  } 
  else {
    println("Ouverture de: " + Texte1Nom);
    println();
    lignes = loadStrings(Texte1Nom);
    minim = new Minim(this);
    // load a file, give the AudioPlayer buffers that are 2048 samples long
    player = minim.loadFile(AudioNom, 2048);
    player.play();
    nums = float(split(lignes[lignes.length - 1 ], "   "));
    DureeFichier = nums[0];
    println("Duree " + Texte1Nom + " = " + DureeFichier + " sec");
    EffaceEcran();
    TempsPause = millis();
  }
}

void draw() {
  temps = millis() - TempsPause;

  if (! Pause) AfficheTemps(temps);
  temps = temps / 1000;

  if (index < lignes.length) {
    nums = float(split(lignes[index], "   "));
    if (Float.isNaN(nums[0])) {
      index = index + 1;
    }
    if (index < 0) {  //Astuce index est > 0
      Ligne = (index * 14) + 20;
      fill(0, 0, 255);
      text(nums[0], 50, Ligne);
      fill(255, 0, 0);
      text(nums[1], 100, Ligne);
    }
    // println("temps = " + temps + "  nums[0] = " + nums[0]);
    if ((temps > nums[0]) && ! Pause) {
      xapres = FacteurX * (width) * nums[0] / DureeFichier;      
      if (((xavant % width) > (xapres % width)) && (index < lignes.length - 10) ) EffaceEcran();
      if (Float.isNaN(nums[1])) {
        index = index + 1;
        Trace = false;
        xavant = xapres; 
        // println("NaN index = " + index);
      }
      else {
        yapres = YPitch(nums[1]) ;
        if (Trace) {
          stroke(0, 0, 0); // Ligne noire
          line(xavant % width, yavant, xapres % width, yapres);
        }
        xavant = xapres;    
        yavant = yapres;
        Trace = true;
        index = index + 1;
      }
    }
  }
  // if (player.isPlaying() == false) {
  //   player = minim.loadFile(AudioNom, 2048);
  //  player.play();
}

float YPitch(float w) {
  return ((500 - w) / 2) + 100;
}

void AfficheTemps(float T) {
  T = T / 1000;
  x = 728;
  fill(0);
  rect(x - 3, 587, 100, 15);
  fill(255);
  text(T + " sec", x, 590);
}

void EffaceEcran() {
  background(255);
  textFont(maFonte, 16);
  fill(0, 0, 0);
  text("Fichier: " + Texte1Nom + "     ("+ lignes.length + " lignes)", 5, 10);
  textFont(maFonte, 12);
  stroke(0, 0, 0);
  line(0, YPitch(75), width, YPitch(75));
  text("75Hz", width - 40, YPitch(75)-10);
  line(0, YPitch(500), width, YPitch(500));
  text("500Hz", width - 40, YPitch(500)-10);
  text("Pause : Espace", width - 85, 575);
  xavant = 0;
  yavant = YPitch(75) ;
}

void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(AudioNom, 2048);
  player.play();
}



void keyPressed() {
  if (key == ' ') {         // barre d'espace
    ToucheEspace = ! ToucheEspace;
    Pause = ToucheEspace;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else   if (keyPressed && (key == CODED)) { // If it's a coded key
    if (keyCode == LEFT) {            // If it's the left arrow
      FacteurX = FacteurX / 2;
      TempsPause = millis();
      index =0;
      EffaceEcran();
      PlayerAudioDebut();
    } 
    else if (keyCode == RIGHT) {      // If it's the right arrow
      FacteurX = FacteurX * 2;
      TempsPause = millis();
      index =0;
      EffaceEcran();
      PlayerAudioDebut();
    }
  }

  {
    // println("key = " + key  + "  Erreur taper Espace");
  }
}

void mousePressed() {
  ;
}

void stop() {
  // always close Minim audio classes when you are done with them
  player.close();
  minim.stop();
  super.stop();
}

